{	This program is copyright (c) 1995 - 2005 Jos Kunst, the Jos Kunst heirs.	}
{	This program is free software. You can redistribute it and/or modify it 	}
{	under the terms of version 2 of the GNU General Public License, which you	}
{	should have received with it.												}
{	This program is distributed in the hope that it will be useful, but			}
{	without any warranty, expressed or implied.									}

unit randomizers;

interface

{NB---optimize random operations by writing:------}
{randseed := integer(tickcount);}
{------at some appropriate place in the program}

	function randnum (upperlimit: integer): integer;

{maximum RANGE with all following "loaded dice" (ldce) functions is:}
{22 if target is at first or last position in range -  30 if target is at center of range}
	function l1dce (range, target: byte): byte;
{ loaded dice }
	function nldce (range, target: byte): byte;
{ negatively loaded dice }
	function l2dce (range, target: byte): byte;
{ doubly loaded dice }
	function l3dce (range, target: byte): byte;
{ three times loaded dice }
	function l4dce (range, target: byte): byte;
 { four times loaded dice }
	function l5dce (range, target: byte): byte;
{ five times loaded dice }
	function l6dce (range, target: byte): byte;
{ absolutely loaded dice: only right on target (the trivial limiting case) (ha ha) }

implementation

	function randnum (upperlimit: integer): integer;
{    var}
{    newseed: integer;}
{    begin}
{    randseed := abs(randseed);}
{    newseed := ((7 * randseed) + 19) mod 1013;}
{    randnum := (randseed mod upperlimit) + 1;}
{    randseed := newseed;}
{    end;}

	begin
		if upperlimit <= 0 then
			randnum := 0
		else
			randnum := abs(random) mod upperlimit + 1
	end;

	function l1dce (range, target: byte): byte; (* loaded dice *)
		var
			maxheight, horcounter, vertcounter, arraycounter: byte;
			ldarr: array[1..255] of byte;
	begin
		maxheight := target;
		if range - (target - 1) > maxheight then
			maxheight := range - (target - 1);
		arraycounter := 0;
		for horcounter := 1 to target do
			for vertcounter := 1 to (maxheight - (target - horcounter)) do
				begin
					arraycounter := arraycounter + 1;
					ldarr[arraycounter] := horcounter
				end;
		for horcounter := target + 1 to range do
			for vertcounter := 1 to (maxheight - (horcounter - target)) do
				begin
					arraycounter := arraycounter + 1;
					ldarr[arraycounter] := horcounter
				end;
		l1dce := ldarr[randnum(arraycounter)]
	end;

	function nldce (range, target: byte): byte; (* negatively loaded dice *)
		var
			t1, t2: byte;
	begin
		t1 := l1dce(range, target);
		t2 := l1dce(range, target);
		if abs(target - t1) < abs(target - t2) then
			nldce := t2
		else
			nldce := t1
	end;

	function l2dce (range, target: byte): byte; (* doubly loaded dice *)
		var
			t1, t2: byte;
	begin
		t1 := l1dce(range, target);
		t2 := l1dce(range, target);
		if abs(target - t1) > abs(target - t2) then
			l2dce := t2
		else
			l2dce := t1
	end;

	function l3dce (range, target: byte): byte; (* three times loaded dice *)
		var
			t1, t2: byte;
	begin
		t1 := l2dce(range, target);
		t2 := l2dce(range, target);
		if abs(target - t1) > abs(target - t2) then
			l3dce := t2
		else
			l3dce := t1
	end;

	function l4dce (range, target: byte): byte; (* four times loaded dice *)
		var
			t1, t2: byte;
	begin
		t1 := l3dce(range, target);
		t2 := l3dce(range, target);
		if abs(target - t1) > abs(target - t2) then
			l4dce := t2
		else
			l4dce := t1
	end;

	function l5dce (range, target: byte): byte; (* five times loaded dice *)
		var
			t1, t2: byte;
	begin
		t1 := l4dce(range, target);
		t2 := l4dce(range, target);
		if abs(target - t1) > abs(target - t2) then
			l5dce := t2
		else
			l5dce := t1
	end;

	function l6dce (range, target: byte): byte;
	begin
		l6dce := target
	end;

end.