{	This program is copyright (c) 1995 - 2005 Jos Kunst, the Jos Kunst heirs.	}
{	This program is free software. You can redistribute it and/or modify it 	}
{	under the terms of version 2 of the GNU General Public License, which you	}
{	should have received with it.												}
{	This program is distributed in the hope that it will be useful, but			}
{	without any warranty, expressed or implied.									}

program chordalfill;
	uses
		translations, randomizers;
	type
		memarr = array[0..17, 1..3] of byte;
{chords that have been used, with the 3 last steps leading away to the next attached to each}
	var
		r, nextr, count, counter: byte;
		chordmem: memarr;
		chordseqtxt: text;
		lefthalfofscreen: rect;

	procedure initialize;
		var
			p, q: byte;
	begin
		for p := 0 to 17 do
			for q := 1 to 3 do
				chordmem[p, q] := 0;
	end;

	procedure showmem (cmem: memarr);
		var
			p, q: byte;
	begin
		for q := 1 to 3 do
			begin
				for p := 0 to 17 do
					write(chordmem[p, q] : 1, ' ');
				writeln
			end;
		writeln
	end;

	function notinmemory (chord, step: byte;
									chmem: memarr): boolean;
		var
			p: byte;
	begin
		notinmemory := TRUE;
		for p := 1 to 3 do
			if chmem[chord, p] = step then
				notinmemory := FALSE
	end;

	procedure updatememoryof (chord, newchord: byte;
									var cmem: memarr);
		var
			p, q: byte;
	begin
		for p := 3 downto 2 do
			cmem[chord, p] := cmem[chord, p - 1];
		cmem[chord, 1] := newchord
	end;

	procedure decideonnextchord (ch: byte;
									var nextch: byte;
									var cmem: memarr);
		var
			st: byte;
	begin
		if ch < 12 then
			begin
				cmem := chordmem;
				repeat
					st := randnum(5);
{deciding on the 5 possible steps away from the 7/5 chord}
				until notinmemory(ch, st, cmem);
				updatememoryof(ch, st, cmem);
				case st of
					1: 
						begin
							nextch := ch + 4;   {possible sequence: c-g --> b-e: I-V in c; 5-4 in e; 4-3 in g#}
							if nextch > 11 then
								nextch := nextch - 12
						end;
					2: 
						begin
							nextch := ch + 6;   {possible sequence: c-g --> c#-f#: 5/3-3/5 in a# and e}
							if nextch > 11 then
								nextch := nextch - 12
						end;
					3: 
						begin
							nextch := ch + 8;    {possible sequence: c-g --> d#-g#: V-I in g#; 5-4 in e; 4-3 in c}
							if nextch > 11 then
								nextch := nextch - 12
						end;
					4: 
						begin
							nextch := ch + 5;     {possible sequence: c-g --> b-f: 4-4 in g#; 5-4 in d#}
{confining to c-f:}
							if nextch < 6 then
								nextch := nextch + 6;
							if nextch < 12 then
								nextch := nextch + 6
						end;
					5: 
						begin
							nextch := ch + 2;    {possible sequence: c-g --> d-g#: 4-4 in c; 5-4 in f}
{confining to c-f:}
							if nextch < 6 then
								nextch := nextch + 6;
							if nextch < 12 then
								nextch := nextch + 6
						end
				end
			end
		else
			begin
				cmem := chordmem;
				repeat
					st := randnum(4);
{deciding on the 4 possible steps away from the 6/6 chord}
				until notinmemory(ch, st, cmem);
				updatememoryof(ch, st, cmem);
				case st of
					1: 
						nextch := ch - 11;    {i.e.: +1-12; possible sequence: c-f# --> c#-g#: 4-4 in a; 4-5 in e}
					2: 
						begin
							nextch := ch - 5;    {i.e.: +7-12; possible sequence: c-f# --> d-g: 4-4 in d#; 4-3 in a#}
							if nextch > 11 then
								nextch := nextch - 12
						end;
					3: 
						begin
							nextch := ch - 2;    {i.e.: +10-12; possible sequence: c-f# --> a#-f: 4-4 in a#; 4-5 in d#}
							if nextch > 11 then
								nextch := nextch - 12
						end;
					4: 
						nextch := ch - 8       {i.e.: +4-12; possible sequence: c-f# --> b-e: 4-4 in e; 4-3 in g#}
				end
			end
	end;

begin{main}
	SetRect(lefthalfofscreen, 9, 44, 502, 856);
	SetTextRect(lefthalfofscreen);
	ShowText;
	randseed := integer(tickcount);
	open(chordseqtxt, 'fifthsfile');
	rewrite(chordseqtxt);
	initialize;
	r := 2;
	writeln(chordseqtxt, nameof(r + 12), '-', nameof(r + 19));
	writeln(nameof(r + 12), '-', nameof(r + 19));
	for counter := 2 to 64 do
{40, 60}
		begin
			decideonnextchord(r, nextr, chordmem);
			r := nextr;
			if r < 12 then
				begin
					write(chordseqtxt, nameof(r + 12), '-');
					write(nameof(r + 12), '-');
					if r < 5 then {hold the other pitch names within the zero octave limits}
						begin
							writeln(chordseqtxt, nameof(r + 19));
							writeln(nameof(r + 19))
						end
					else
						begin
							writeln(chordseqtxt, nameof(r + 7));
							writeln(nameof(r + 7))
						end
				end
			else
				begin
					writeln(chordseqtxt, nameof(r), '-', nameof(r + 6));
					writeln(nameof(r), '-', nameof(r + 6))
				end
		end
end.{main}